<template>
  <section class="dashboard-content text-center">
    <main role="main" class="container">
      <div class="starter-template pb-3">
        <button
          type="button"
          data-dismiss="modal"
          aria-label="Close"
          class="close"
          v-on:click="$router.replace('/')"
        >
          <i class="icon-close f-18"></i>
        </button>
      </div>

      <div class="starter-template pb-3">
        <div class="sent" v-if="!!receiverKey">
          <h1
            class="f-72 mb-0 d-flex align-items-center justify-content-center"
            v-if="!failed && sent"
          >
            <span class="ml-1">{{amount | minor-unit-currency}} Sent</span>
          </h1>
          <h1
            class="f-72 mb-0 d-flex align-items-center justify-content-center"
            v-if="!failed && !sent"
          >
            <span class="ml-1">Sending &nbsp;</span>
            <span class="ml-1">{{amount | minor-unit-currency}}</span>
          </h1>

          <p class="f-28" v-if="sent">
            <i class="icon-check f-26 mt--2"></i>
            <span class="ml-1" v-html="statusMessage" />
          </p>
          <p class="f-28" v-if="!failed && !sent">
            <i class="icon-waiting f-24 mt--2"></i>
            <span class="ml-1" v-html="statusMessage" />
          </p>
          <p class="f-28" v-if="failed">
            <i class="icon-close f-20 mt--2"></i>
            <span class="ml-1" v-html="statusMessage" />
          </p>
        </div>
        <div class="received" v-else>
          <h1 class="f-36 mb-0 d-flex align-items-center justify-content-center">
            <span class="ml-1">You've received money!</span>
          </h1>
          <p class="f-72">
            <span class="ml-1">{{amount | minor-unit-currency}}</span>
          </p>
        </div>

        <div class="clearfix mb-3"></div>
        <div class="w600 m-auto border-top border-bottom">
          <div class="form-wrapper m-auto pt-3">
            <table class="table table-borderless text-left f-16">
              <tbody>
                <tr v-if="txid">
                  <th scope="col">Txn&nbsp;ID#</th>
                  <td>
                    <input
                      type="text"
                      class="key text-truncate d-inline-block border-0 p-0 w-100"
                      id="txId"
                      v-on:click.prevent="copyTxId($event)"
                      data-toggle="tooltip"
                      data-placement="bottom"
                      v-bind:value="txid"
                      v-bind:title="txid"
                      readonly
                    />
                  </td>
                </tr>
                <tr>
                  <th v-if="!!receiverKey" scope="col">To:</th>
                  <th v-else scope="col">From:</th>
                  <td>
                    <span class="f-16 mt--2 receipt receipt-txn text-truncate">
                      <p class="receipt" v-if="contact.contactName">{{contact.contactName}}</p>
                      <p class="receipt" v-if="contact.company">{{contact.company}}</p>
                      <input
                        type="text"
                        class="key text-truncate d-inline-block border-0 p-0 w-100"
                        id="contactAddress"
                        v-on:click.prevent="copyContactAddress($event)"
                        data-toggle="tooltip"
                        data-placement="bottom"
                        v-bind:value="contact.address"
                        v-bind:title="contact.address"
                        readonly
                      />
                    </span>
                  </td>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
        <div class="form-wrapper m-auto pt-4">
          <p v-if="sent">
            Wallet Balance:
            <span class="ml-1">{{viewBalanceInMinorUnit | minor-unit-currency}}</span>
          </p>
          <button
            type="submit"
            class="btn btn-success btn-send btn-send-screen-lg f-18"
            v-on:click="$router.replace('/')"
          >OK</button>
          <div class="clearfix"></div>
        </div>
      </div>
    </main>
  </section>
</template>
<script lang="ts">
import { Inject } from "inversify-props";
import util from "util";
import { Component, Prop } from "vue-property-decorator";
import { Transaction, TransactionState } from "xand-member-api-client";
import { mixins } from "vue-class-component";

import { loggerIndex, loggerMessage } from "@/constants/logger";
import displayMessages from "@/constants/displayMessages";
import CopyToClipboard from "@/mixins/CopyToClipboard";
import { IMemberApiService } from "@/services/IMemberApiService";
import StoreModules from "@/mixins/StoreModules";
import Contact from "@/models/Contact";

@Component
export default class Receipt extends mixins(CopyToClipboard, StoreModules) {
  @Inject("IMemberApiService")
  public api!: IMemberApiService;

  // props
  @Prop(String) public readonly txid: string | undefined;
  @Prop(String) public readonly receiverKey: string | undefined;
  @Prop([Number, String]) public readonly amount: number | string | undefined;
  @Prop(String) public readonly senderKey: string | undefined;
  @Prop({ default: "false" }) public readonly isSent!: string;

  public sent: boolean | null = this.isSent.toUpperCase() === "TRUE";
  public failed: boolean | null = false;
  public statusMessage: string | null = null;

  get contact(): Contact {
    let contact = {
      address: this.receiverKey || this.senderKey || "",
      company: "",
      contactName: ""
    };
    if (contact.address) {
      const existingContact = this.contactsModule.contacts[contact.address];
      contact = { ...existingContact, address: contact.address };
    }
    return contact;
  }

  get viewBalanceInMinorUnit() {
    return this.userModule.userDetails.userBalanceInMinorUnit;
  }

  public created() {
    if (this.receiverKey && this.txid && !this.sent) {
      this.failed = false;
      this.statusMessage = displayMessages.WAITING_SEND_STATUS;
      this.$remoteLogger.info(
        loggerIndex.INFO_.SER0017 +
          loggerMessage.TRANSACTION_STATUS_FETCH_MANUALLY +
          this.txid
      );
      this.waitForSend(this.txid);
    } else if (this.sent) {
      this.statusMessage = displayMessages.SUCCESSFUL_SEND_STATUS;
    }
  }

  public copyContactAddress(event: MouseEvent) {
    this.copyToClipboard(
      event.target,
      displayMessages.PUBLIC_ADDRESS_COPIED,
      loggerMessage.PUBLIC_ADDRESS_COPIED,
      loggerMessage.PUBLIC_ADDRESS_COPYING_FAILED
    );
  }

  public copyTxId(event: MouseEvent) {
    this.copyToClipboard(
      event.target,
      displayMessages.TRANSACTION_COPIED,
      loggerMessage.TRANSACTION_COPIED,
      loggerMessage.TRANSACTION_COPYING_FAILED
    );
  }

  public async waitForSend(txId: string) {
    try {
      const tx = await this.api.pollForTxConfirmation(
        txId,
        (t: Transaction) => {
          this.$remoteLogger.warn(
            loggerIndex.WARN_.SER0009 +
              loggerMessage.TRANSACTION_STATUS_FETCH_PENDING +
              txId +
              loggerMessage.SEPARATOR_MSG +
              util.inspect(t)
          );
        }
      );
      switch (tx.status.state) {
        case TransactionState.Confirmed:
          this.statusMessage = displayMessages.SUCCESSFUL_SEND_STATUS;
          this.$remoteLogger.info(
            loggerIndex.INFO_.SER0016 +
              loggerMessage.TRANSACTION_STATUS_FETCH_SUCCESSFULLY +
              txId +
              loggerMessage.SEPARATOR_MSG +
              util.inspect(tx)
          );
          this.sent = true;
          this.failed = false;
          break;
        case TransactionState.Invalid:
          this.statusMessage = displayMessages.FAILED_SEND_STATUS;
          this.$remoteLogger.error(
            loggerIndex.ERR_.SER0033 +
              loggerMessage.TRANSACTION_STATUS_FETCH_INVALID +
              txId +
              loggerMessage.SEPARATOR_MSG +
              util.inspect(tx)
          );
          this.sent = false;
          this.failed = true;
          break;
        default:
          // 'Unknown'
          this.sent = false;
          this.failed = false;
          this.statusMessage =
            loggerMessage.TRANSACTION_STATUS_FETCH_UNKNOWN + txId;
          this.$remoteLogger.error(
            loggerIndex.ERR_.SER0034 +
              loggerMessage.TRANSACTION_STATUS_FETCH_UNKNOWN +
              txId +
              loggerMessage.SEPARATOR_MSG +
              util.inspect(tx)
          );
          break;
      }
      this.userModule.refreshUserDetails(this.$txToast);
    } catch (err) {
      this.statusMessage = displayMessages.SEND_POLL_FAILURE;
      this.$remoteLogger.error(loggerIndex.ERR_.SER0035 + util.inspect(err));
      this.userModule.refreshUserDetails(this.$txToast);
    }
  }
}
</script>
<style lang="scss" />
